// server.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <winsock2.h>;
#include <fstream.h>
#include "messages.h"

#define MAX_LOADSTRING 100

#define Say(_str) MessageBox(hWnd,_str,"Message",0);



// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

HWND hWnd;
HWND hEdit1,hEdit2,hEdit3,hButton1;

int PORT=2345;
SOCKET socket1;
sockaddr_in addr1,addr2;
WSADATA data1;
struct hostent FAR *info;
TCHAR szLocalName[128];

const int ID_EDIT1=1245;
const int ID_EDIT2=1246;
const int ID_EDIT3=1247;
const int MAX_DATA=1000;
const int ID_BUTTON1=11111;

HANDLE hThread2;
DWORD dwThread2ID;

int *PrimeNumbers;
int LastProcessingNumber=0;

ofstream out("result.txt");

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void                InitSocket();
DWORD WINAPI        SecondThreadFunction(PVOID pvParam);
void                SetResult(int* Message);
void                GiveNewJob(sockaddr_in);

void InitSocket()
{
	WSAStartup(0x202,&data1);
	ZeroMemory(szLocalName,sizeof(szLocalName));
	addr1.sin_family=AF_INET;
	addr1.sin_addr.s_addr=INADDR_ANY;
	addr1.sin_port=htons(PORT);

	socket1=socket(AF_INET,SOCK_DGRAM,0);
	if(socket1==-1) Say("socket failed");
	if(bind(socket1,(const struct sockaddr*)&addr1,sizeof(addr1))==-1) Say("bind failed");
}

DWORD WINAPI SecondThreadFunction(PVOID pvParam)
{
	while(1)
	{
		int Data[MAX_DATA];
		int size=sizeof(addr2);
		recvfrom(socket1,(char*)Data,MAX_DATA,0,(struct sockaddr*)&addr2,&size);
		if(Data[0]==CM_RESULT) SetResult(Data);
		if(Data[0]==CM_NEW) GiveNewJob(addr2);

	}
}

void SetResult(int* Message)
{
	int *Data=&Message[1];
	int nTotal=Data[0];
	int nFrom=Data[1];
	int nTo=Data[2];
	for(int i=3;i<nTotal;i++)
	{
		out <<"fhgfh  "<<Data[i]<<endl;
		Say("kdgfkdg");
//		VirtualAlloc((PrimeNumbers+i-3),2,MEM_COMMIT,PAGE_READWRITE);
//		*(PrimeNumbers+i-3)=Data[i];
	}
}

void GiveNewJob(sockaddr_in addr)
{
	BYTE Message;
	int From,To;
	if(LastProcessingNumber>=20000000)
	{
		Message=CM_COMPLETED;
		return;
	}
	if(LastProcessingNumber>19998999)
		To=20000000;
	else To=LastProcessingNumber+1000;
	From=LastProcessingNumber+1;
	Message=CM_TASK;
	BYTE Data[MAX_DATA];
	Data[0]=Message;
	int *IData;
	IData=(int*)Data+1;
	IData[0]=From;
	IData[1]=To;
	sendto(socket1,(char*)Data,MAX_DATA,0,(const sockaddr*)&addr,sizeof(addr));
	LastProcessingNumber+=1000;
	char buffer[10];
	ZeroMemory(buffer,10);
	wsprintf(buffer,"%d",LastProcessingNumber);
	SendMessage(hEdit1,WM_SETTEXT,0,(long)buffer);
}

void SaveToFile()
{
}


//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_CREATE:
			{
				PrimeNumbers=(int*)VirtualAlloc(NULL,2147483648,MEM_RESERVE,PAGE_READWRITE);
				InitSocket();
				hThread2=CreateThread(NULL,0,SecondThreadFunction,NULL,0,&dwThread2ID);
			}
			break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{

				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SERVER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SERVER);

	hEdit1=CreateWindow("EDIT",NULL,WS_VISIBLE|WS_CHILD,100,100,100,20,
		hWnd,(HMENU)ID_EDIT1,GetModuleHandle(NULL),NULL);
	hEdit2=CreateWindow("EDIT",NULL,WS_VISIBLE|WS_CHILD,50,50,50,20,
		hWnd,(HMENU)ID_EDIT2,GetModuleHandle(NULL),NULL);
	hEdit3=CreateWindow("EDIT",NULL,WS_VISIBLE|WS_CHILD,150,50,50,20,
		hWnd,(HMENU)ID_EDIT3,GetModuleHandle(NULL),NULL);
	hButton1=CreateWindow("EDIT",NULL,WS_VISIBLE|WS_CHILD,150,50,50,20,
		hWnd,(HMENU)ID_BUTTON1,GetModuleHandle(NULL),NULL);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_SERVER);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW);
	wcex.lpszMenuName	= (LPCSTR)IDC_SERVER;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   MoveWindow(hWnd,100,100,300,300,TRUE);

   return TRUE;
}


// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
